//Rtc_RX8025_i2c.c
//Epson RTC RX-8025pCu
#include "Rtc_RX8025_i2c.h"
#include <xc.h> //ǉ  K{ for WX^Lq

unsigned char Reg_RTC[16];   //RTC8025̃WX^liBCDlj

void RX8025_delay_us_i2c(unsigned int usec)        //1secx֐
{
    int count;

	count = (int)(lcd_Clock_i2c/20000000)*usec;

        do      //F@at@200MH (Clock=200000000)
        {       //delay_us(1000)1000.4secA@delay_us(100)100.6secAdelay_us(10)10.5secAdelay_us(1)1.5sec
                asm("NOP"); asm("NOP"); asm("NOP"); asm("NOP"); asm("NOP");asm("NOP");
                asm("NOP"); asm("NOP"); asm("NOP"); asm("NOP"); asm("NOP"); asm("NOP");

                count--;
        }while(count != 0);
}

void RX8025_delay_ms_i2c(unsigned int msec)        //1msecx֐
{
     unsigned int i;

	for(i=0; i<msec; i++)
	RX8025_delay_us_i2c(1000);
}


//BCDoCi(10i)ɕϊ
unsigned char RX8025_BCDToBinary(unsigned char dt)
{
    unsigned char temp;
    temp =  ((dt >> 4) * 10) + (dt & 0xf) ;
    return temp ;
}


// oCi(10i)BCDɕϊ
unsigned char RX8025_BinaryToBCD(unsigned char num)     //bAAAAAN@ׂā@1oCg@//NF00-99    //2000?2099N܂łv͈
{
     return ((num/100) << 8) | ( ((num%100) / 10) << 4 ) | (num%10) ;
}

void RX8025_Idle_i2c(void)  //ACh҂
{
     while(I2CYCONbits.SEN || I2CYCONbits.PEN || I2CYCONbits.RCEN || I2CYCONbits.RSEN
           || I2CYCONbits.ACKEN || I2CYSTATbits.TRSTAT);
}

void RX8025_Start_i2c()
{
    RX8025_Idle_i2c();  //ACh҂
    I2CYCONbits.SEN = 1;    // X^[go//
    while(I2CYCONbits.SEN); // X^[gI҂
    RX8025_Idle_i2c();  //ACh҂
}

void RX8025_ReStart_i2c()
{
    RX8025_Idle_i2c();  //ACh҂
    I2CYCONbits.RSEN = 1;    // X^[go//
    while(I2CYCONbits.RSEN); // X^[gI҂
    RX8025_Idle_i2c();  //ACh҂
}

void RX8025_Stop_i2c()
{
    I2CYCONbits.PEN = 1;     // Xgbvo
    while(I2CYCONbits.PEN); // XgbvI҂

}

void RX8025_Reset_i2C(void)
{
    I2CYCONbits.ON = 0;      //IC2W[FOFF
    I2CYCONbits.ON = 1;      //IC2W[FON
}


void RX8025_WriteByte_i2c(unsigned char byte)  //1oCg
{
   
    RX8025_Idle_i2c();              // ACh҂
    I2CYTRN = byte;                 // f[^ZbgMJn
    while(I2CYSTATbits.TBF);        // MI҂
    while(I2CYSTATbits.ACKSTAT);    // ACKԐM҂
    RX8025_Idle_i2c();              // ACh҂
}

unsigned char RX8025_Read_EachReg(int ack)
{
    unsigned char data ;
    RX8025_Idle_i2c();
    I2CYCONbits.RCEN = 1;           //M
    while(!I2CYSTATbits.RBF);       //Mobt@I2CXRCV@tɂȂ܂ő҂@ //Receive complete, I2CxRCV is full
    RX8025_Idle_i2c();
   
    data = I2CYRCV;                 //Mobt@I2CXRCVǂݍ
    RX8025_Idle_i2c();
    
    I2C2CONbits.ACKDT = ack;
    I2C2CONbits.ACKEN = 1;
     
    return data ;
}

void RX8025_Read_AllReg(unsigned char* ptrReg)
{
    int rw;    //ǂ/݃[h
    int adrs = RTC_ADRS;   //RX8025̃X[uAhX
    
    RX8025_Start_i2c();     //X^[gRfBVs
    rw = 0;    //݃[h
    I2CYTRN = (char)((adrs<<1)+rw) ;     // AhX + R/W𑗐M;                 // f[^ZbgMJn
    while(I2CYSTATbits.TBF);        // MI҂
    while(I2CYSTATbits.ACKSTAT);    // ACKԐM҂
                                    //ACKSTAT: Acknowledge Status bit   //1 = NACK received from slave, 0 = ACK received from slave
    RX8025_Idle_i2c();  //ACh҂
    RX8025_WriteByte_i2c(0x00) ;              // SecWX^AhX0x00݁iI2oXɑM) 
    
    RX8025_ReStart_i2c();   //s[gEX^[gRfBVs      //ɔs
    
    rw = 1;    //ǂݍ݃[h
    I2CYTRN = (char)((adrs<<1)+rw) ;     // AhX + R/W𑗐M
    while(I2CYSTATbits.TBF);        // MI҂
    while(I2CYSTATbits.ACKSTAT);    // ACKԐM҂
    
    Reg_RTC[0] = RX8025_Read_EachReg(0); //0x00   Sec 
    Reg_RTC[1] = RX8025_Read_EachReg(0); //0x01  Min
    Reg_RTC[2] = RX8025_Read_EachReg(0); //0x02  Hour
    Reg_RTC[3] = RX8025_Read_EachReg(0); //0x03  Week
    Reg_RTC[4] = RX8025_Read_EachReg(0);//0x04  Day 
    Reg_RTC[5] = RX8025_Read_EachReg(0); //0x05  Mon
    Reg_RTC[6] = RX8025_Read_EachReg(1); //0x06  Year   //Ō̃f[^ǂݏoȂ̂NACK𑗐M
    
    RX8025_Stop_i2c();      //XgbvM
    RX8025_Idle_i2c();      //ACh҂
}








void RX8025_RTC_Init(char year20XX,char Mon,char Day,char Week,char Hour,char Min,char Sec)
{
    int rw = 0;    //݃[h
    int adrs = RTC_ADRS;   //RX8025̃X[uAhX

    RX8025_Start_i2c();     //X^[gRfBVs
    RX8025_ReStart_i2c();   //s[gEX^[gRfBVs      //ɔs
    
    I2CYTRN = (char)((adrs<<1)+rw) ;     // AhX + R/W𑗐M;                 // f[^ZbgMJn
    while(I2CYSTATbits.TBF);        // MI҂
    while(I2CYSTATbits.ACKSTAT);    // ACKԐM҂
                                    //ACKSTAT: Acknowledge Status bit   //1 = NACK received from slave, 0 = ACK received from slave
    RX8025_Idle_i2c();  //ACh҂
    
    //RX8025́At̐mۂ邽ߔU~ȂŏނƂAAď܂ȂƐ߂Ȃ
    RX8025_WriteByte_i2c(0x00) ;              // SecWX^AhX0x00݁iI2oXɑM)     
    RX8025_WriteByte_i2c(RX8025_BinaryToBCD(Sec)) ;// SecWX^ւ̒libj    //݃WX^0x00
    RX8025_WriteByte_i2c(RX8025_BinaryToBCD(Min)) ;// MinWX^ւ̒lij    //݃WX^0x01ɃCNg
    RX8025_WriteByte_i2c(RX8025_BinaryToBCD(Hour));// HourWX^ւ̒lij   //݃WX^0x02ɃCNg
    RX8025_WriteByte_i2c(RX8025_BinaryToBCD(Week));// WeekWX^ւ̒l(j0-6)//݃WX^0x03ɃCNg
    RX8025_WriteByte_i2c(RX8025_BinaryToBCD(Day));// DayWX^ւ̒l()       //݃WX^0x04ɃCNg
    RX8025_WriteByte_i2c(RX8025_BinaryToBCD(Mon)) ;// MonWX^ւ̒lij    //݃WX^0x05ɃCNg
    RX8025_WriteByte_i2c(RX8025_BinaryToBCD(year20XX));// YearWX^ւ̒li2Nj   //݃WX^0x06ɃCNg
    RX8025_WriteByte_i2c(0x00);   //Digidal OffsetivxjWX^F//݃WX^0x07ɃCNg //gpȂ̂0x00Zbg
    RX8025_WriteByte_i2c(0x00);   //AlarmW_MinWX^    //݃WX^0x08ɃCNg  //gp                
    RX8025_WriteByte_i2c(0x00);   //AlarmW_HourWX^   //݃WX^0x09ɃCNg  //gp                
    RX8025_WriteByte_i2c(0x00);   //AlarmW_WeekWX^   //݃WX^0x0AɃCNg  //gp  
    RX8025_WriteByte_i2c(0x00);   //AlarmD_MinWX^    //݃WX^0x0BɃCNg  //gp       
    RX8025_WriteByte_i2c(0x00);   //AlarmD_HourWX^   //݃WX^0x0CɃCNg  //gp         
    RX8025_WriteByte_i2c(0x00);   //Reserved              //݃WX^0x0DɃCNg //Control1A2WX^փCNg邽߂Ɏs
    RX8025_WriteByte_i2c(0x20);   //Control1WX^      //݃WX^0x0EɃCNg  //b5=1 -->24ԕ\@@//ijߌ530:@17F30          
    RX8025_WriteByte_i2c(0x80);   //Control2WX^      //݃WX^0x0FɃCNg  //b7=1 -->ddቺox@1.3V@ivs b7 = 0  --> 2.1V)  

    RX8025_Stop_i2c();  // XgbvRfBVs
    RX8025_delay_ms_i2c(10);
}
